

function tank_bisect_plot
                                % continous function.
  m = 200 ;
  a0=1 ;
  b0=5 ;
  x = linspace(a0,b0,m);
  for i=1:m 
    y(i) = sTank(x(i)) ;
  endfor

                                %figure('Position',[0,0,25,15]);

                                %step 0, init
  i=2 ;
  xa = a0 ;
  xb = b0 ;
  [xl,xm,xr] = plotbis( x, y, xa, xb, i ) ;
  print ( 'tank-bis0.svg', '-dsvg', '-landscape' )

  pause

                                % step 1
  i = 3 ;
  xa = xa ;
  xb = xm ;
  [xl,xm,xr] = plotbis( x, y, xa, xb, i ) ;
  print ( 'tank-bis1.svg', '-dsvg', '-landscape' )

  pause

                                % step 2
  i=4;
  xa = xl ;
  xb = xr ;
  [xl,xm,xr] = plotbis( x, y, xa, xb,i ) ;
  print ( 'tank-bis2.svg', '-dsvg', '-landscape' )

  pause

                                % step 3
  i=2;
  xa = xm ;
  xb = xb ;
  [xl,xm,xr] = plotbis( x, y, xa, xb,i ) ;
  print ( 'tank-bis3.svg', '-dsvg', '-landscape' )

  pause
endfunction

function surface = sTank (xx)
  vStar = 5 ;
  surface = 4*vStar/xx + xx^2 ;
endfunction

function [xl, xm, xr] = plotbis ( x, y, xa, xb,i ) 
  hold off
  plot(x,y, "linewidth", 2)

  ax = gca ();
  set (ax, "linewidth", 2 ) ;
  xlabel("x_2")
  ylabel("S")
  hold on

  xl = (3*xa+xb)/4 ;
  xm = (xa+xb)/2 ;
  xr = (xa+3*xb)/4 ;
  z = [ xa, xl, xm, xr, xb ] ;
  yz = [ sTank(z(1)), sTank(z(2)), sTank(z(3)), sTank(z(4)), sTank(z(5)) ] ;
  plot(z,yz, "ks", "linewidth", 2)

  % highlight fmin:
  plot ( z(i), yz(i), "rs", "linewidth", 2 ) ;
endfunction

